// Sedgewick and Wayne, Algorithms, 4th ed. problem 1.3.44

// I would never use this in real life.  It's far too inefficient.

#include "Buffer.hpp"

Buffer::Buffer( void ) :
    cursor (0),
    use_s1 (true)
    {
    }

void Buffer::insert( char c ) {
    if ( use_s1 ) {
        size_t i = 0;
        size_t max = s1.size();
        while ( i != cursor )
            s2.push( s1.pop() );
        s2.push( c );
        while ( i < max )
            s2.push( s1.pop() );
        }
    else {
        size_t i = 0;
        size_t max = s2.size();
        while ( i != cursor )
            s1.push( s2.pop() );
        s1.push( c );
        while ( i < max )
            s1.push( s2.pop() );
        }
    }

char Buffer::get( void ) {
    if ( use_s1 )
        return s1.find( cursor );       // Need to add overloaded T find( size_t k) to Stack
    else
        return s2.find( cursor );
    }

char Buffer::delete( void ) {
    if ( use_s1 ) {
        size_t i = 0;
        size_t max = s1.size();
        while ( i != cursor )
            s2.push( s1.pop() );
        ++i;
        while ( i < max )
            s2.push( s1.pop() );
        }
    else {
        size_t i = 0;
        size_t max = s2.size();
        while ( i != cursor )
            s1.push( s2.pop() );
        ++i;
        while ( i < max )
            s1.push( s2.pop() );
        }

    if ( cursor > size() )
        cursor = size();
    }

void Buffer::left( size_t k ) {
    if ( cursor < k )
        cursor = 0;
    else
        cursor -= k;
    }

void Buffer::right( size_t k ) {
    if ( size() - cursor < k )
        cursor = size();
    else
        cursor += k;
    }

size_t Buffer::size( void ) {
    if ( use_s1 )
        return s1.size();
    else
        return s2.size();
    }
