// g++ -std=c++11 CircularQueue.cpp

#include <cstddef>
#include <cstdlib>
#include <iostream>

#include "CircularQueue.hpp"

int main( int argc, char **argv ) {
    size_t max;
    std::cin >> max;
    if ( ! std::cin.good() ) {
        std::cerr << "You must enter a size for the queue." << std::endl;
        exit( EXIT_FAILURE );
        }
    
    CircularQueue<long> queue( max );

    long i;
    while ( ! std::cin.eof() ) {
        std::cin >> i;
        if ( std::cin.good() ) {
            if ( queue.full() )
                std::cout << "Queue is full: old data lost" << std::endl;
            queue.enqueue(i);
            }
        }

    std::cout << "Queue has " << queue.size() << " entries." << std::endl;

    std::cout << "Dequeuing entries:" << std::endl;
    while ( ! queue.empty() ) {
        long i = queue.dequeue();
        std::cout << i << std::endl;
        }

    }
