// 1.3.38 Stack based implementation

#ifndef GENERALIZEDQUEUE_HPP
#define GENERALIZEDQUEUE_HPP

#include <cassert>
#include <cstddef>

template <typename T>
class GeneralizedQueue {

private:

    ////////////////////////////////////
    class Node {
    public:
        T item;
        Node *next;
        };

    ////////////////////////////////////

public:
    GeneralizedQueue( void );
    bool is_empty( void );
    void insert( T item );
    T remove( size_t k );

private:
    Node *data;

    };

////////////////////////////////////////////////////////////////////////////////

template <typename T>
GeneralizedQueue<T>::GeneralizedQueue( void ) :
    data (nullptr)
    {
    }

template <typename T>
bool GeneralizedQueue<T>::is_empty( void ) {
    return ! ( data == nullptr );
    }

template <typename T>
void GeneralizedQueue<T>::insert( T item ) {
    Node *node = new Node();
    node.item = item;
    node.next = nullptr;

    if ( data == nullptr ) {
        data = node;
        }
    else {
        Node *curr = data;
        while ( curr->next )
            curr = curr->next;
        curr->next = node;
        }
    }

template <typename T>
T GeneralizedQueue<T>::remove( size_t k ) {
    assert( data != nullptr );

    Node *prev = nullptr;
    Node *curr = data;
    size_t i = 0;
    T item;
    while ( i < k ) {
        assert( curr->next );
        prev = curr;
        curr = curr->next;
        }

    if ( prev )
        prev->next = curr->next;
    else
        data = curr->next;
    item = curr->item;
    delete curr;

    return item;
    }

#endif
