#include <algorithm>
#include <cstdlib>
#include <iostream>
#include <sstream>

#include "Queue.hpp"

void usage( char * name ) {
    std::cerr << name << " skip size" << std::endl;
    exit( EXIT_FAILURE );
    }


int read_int( char *s ) {
    std::stringstream ss;

    ss.str( s );
    int tmp;
    ss >> tmp;
    if ( ss.fail() ) {
        return -1;
        }
    return tmp;
    }

int main( int argc, char **argv ) {

    if ( argc != 3 ) {
        usage( argv[0] );
        }

    int skip = read_int( argv[1] );;
    int size = read_int( argv[2] );
    if ( skip == -1 || size == -1 ) {
        usage( argv[0] );
        }


    Queue<int> q;

    for ( int i = 0; i < size; ++i ) {
        q.enqueue( i );
        }

    int i = 0;
    while ( q.size() ) {
        int tmp = q.dequeue();
        if ( (i+1) % skip )
            q.enqueue( tmp );
        else
            std::cout << tmp << std::endl;
        ++i;
        }
    
    }
