// g++ -std=c++11 RandomQueue.cpp

#include <iostream>

#include "RandomQueue.hpp"

int main ( int argc, char **argv ) {

    RandomQueue<long> q;

    long i;
    while ( ! std::cin.eof() ) {
        std::cin >> i;
        if ( std::cin.good() ) {
            q.enqueue(i);
            }
        }

    std::cout << "RandomQueue has " << q.size() << " entries." << std::endl;

    for ( auto iter = q.begin(); iter != q.end(); ++iter ) {
        std::cout << *iter << std::endl;
        }

    std::cout << "Sampling entries." << std::endl;

    for ( int i; i < q.size(); ++i ) {
        std::cout << q.sample() << std::endl;
        }

    std::cout << "Removing entries entries..." << std::endl;

    while ( ! q.is_empty() ) {
        i = q.dequeue();
        std::cout << i << std::endl;
        }

    std::cout << "Q has " << q.size() << " entries." << std::endl;

    }

