// g++ -std=c++11 ResizingArrayDeque.cpp


#include "ResizingArrayDeque.hpp"

#include <iostream>

int main ( int argc, char **argv ) {

    ResizingArrayDeque<long> deque;
    bool left = true;

    long i;
    while ( ! std::cin.eof() ) {
        std::cin >> i;
        if ( std::cin.good() ) {
            if ( left ) {
                deque.push_left(i);
                left = false;
                }
            else {
                deque.push_right(i);
                left = true;
                }
            }
        }

    std::cout << "Deque has " << deque.size() << " entries." << std::endl;

    for ( auto iter = deque.begin(); iter != deque.end(); ++iter ) {
        std::cout << *iter << std::endl;
        }

    std::cout << "Popping entries..." << std::endl;

    left = true;
    while ( ! deque.is_empty() ) {
        if ( left ) {
            i = deque.pop_left();
            left = false;
            }
        else {
            i = deque.pop_right();
            left = true;
            }
        std::cout << i << std::endl;
        }

    std::cout << "Deque has " << deque.size() << " entries." << std::endl;

    }

