// g++ -std=c++11 Stack.cpp


#include "Stack.hpp"

#include <iostream>

int main ( int argc, char **argv ) {

    Stack<long> stack;

    long i;
    while ( ! std::cin.eof() ) {
        std::cin >> i;
        if ( std::cin.good() ) 
            stack.push(i);
        }

    std::cout << "Stack has " << stack.size() << " entries." << std::endl;

    for ( auto iter = stack.begin(); iter != stack.end(); ++iter ) {
        std::cout << *iter << std::endl;
        }

#ifdef EXERCISES
    std::cout << "Looking for 3: " << ( stack.find( 3 ) ? "found" : "not found" ) << std::endl;
    std::cout << "Looking for 9999: " << ( stack.find( 9999 ) ? "found" : "not found" ) << std::endl;

    std::cout << "Removing bottom entry: ";
    i = stack.delete_bottom();
    std::cout << i << std::endl;
    std::cout << "Stack has " << stack.size() << " entries." << std::endl;

    for ( auto iter = stack.begin(); iter != stack.end(); ++iter ) {
        std::cout << *iter << std::endl;
        }

    std::cout << "Removing entry 2: ";
    i = stack.remove( 2 );
    std::cout << i << std::endl;
    std::cout << "Stack has " << stack.size() << " entries." << std::endl;

    for ( auto iter = stack.begin(); iter != stack.end(); ++iter ) {
        std::cout << *iter << std::endl;
        }

#endif

    std::cout << "Popping entries..." << std::endl;

    while ( ! stack.is_empty() ) {
        i = stack.pop();
        std::cout << i << std::endl;
        }

    std::cout << "Stack has " << stack.size() << " entries." << std::endl;

    }
